#ifndef EP_LIB_MPI_HPP_INCLUDED
#define EP_LIB_MPI_HPP_INCLUDED

namespace ep_lib
{

  typedef void* MPI_Datatype;
  typedef void* MPI_Op;


  int MPI_Send_mpi      (void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm);
  int MPI_Ssend_mpi      (void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm);
  int MPI_Isend_mpi      (const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);
  int MPI_Issend_mpi      (const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);
  
  
  int MPI_Recv_mpi      (void *buf, int count, MPI_Datatype datatype, int src, int tag, MPI_Comm comm, MPI_Status *status);
  int MPI_Irecv_mpi      (void *buf, int count, MPI_Datatype datatype, int src, int tag, MPI_Comm comm, MPI_Request *request);

  int MPI_Iprobe_mpi(int source, int tag, MPI_Comm comm, int *flag, MPI_Status *status);
  int MPI_Improbe_mpi(int src, int tag, MPI_Comm comm, int *flag, MPI_Message *message, MPI_Status *status);
  
  int MPI_Comm_rank_mpi(MPI_Comm comm, int* rank);
  int MPI_Comm_size_mpi(MPI_Comm comm, int* size);
  int MPI_Comm_remote_size_mpi(MPI_Comm comm, int* size);

  int MPI_Comm_dup_mpi(MPI_Comm comm, MPI_Comm *newcomm);
  int MPI_Comm_free_mpi(MPI_Comm *comm);

  int MPI_Barrier_mpi(MPI_Comm comm);
  
  int MPI_Intercomm_create_mpi(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);

}

#endif // EP_LIB_MPI_HPP_INCLUDED
